#
#Author: Russell Nelson
#Bastardized by Greg Berenfield
#Licnese: GPL
#Date: 05/16/2001
#Program: ipaddr.py
#Version: 0.01a
#

#### Feel free to delete all my dumb comments :)

name = "IPaddr"
desc = "Set System's IP address"
glade_file = 'ipaddr.glade'

from gtk import *
from GTK import *
from utils import *
import string
import re

# for testing on my laptop
sys.path.append('/root/python/sysset/applets/mods')
import profmod

def int_to_ip_addr(ip):
    return "%u.%u.%u.%u" % ((ip >>24 & 255), (ip>>16 & 255), (ip>>8 & 255), (ip & 255))

def ip_addr_to_int(ipaddr):
    s = string.split(ipaddr, '.')
    print s
    if len(s) != 4:
        return 0
    try:
        return (int(s[0])<<24) + (int(s[1])<<16) + (int(s[2])<<8) + int(s[3])
    except:
        return 0



#### a few globals for my xml junk
aval={} #### may be a better way but it works
modulename="IPADDR" #### Salt this one to taste! (Name of specific applet)
#### Only modulename should be set.. rest of readprofile code won't need to be changed by applet authors.





class applet(Applet):
    manualnames = ['IPADDR', 'NETMASK', 'NETWORK', 'BROADCAST', 'GATEWAY', 'DHCP_HOSTNAME']
    #### Added DHCP_HOSTNAME. PUMP a bit of a problem for ease of use.. need to address
    #### I am having problems setting PUMP's widget however..prolly checkboxes don't have values per se (too lazy to lookup :)
    fn = '/etc/pcmcia/network.opts'
#    fn = '/tmp/network.opts'  #### leaving fn as this so I don't play with my laptop's network.opts ;)

    def on_subnetbits_value_changed(self, adj):
        netmask = ~0 << (32-int(adj.value))
        self.widgets['NETMASK'].set_text(int_to_ip_addr(netmask))
        ipaddr = ip_addr_to_int(self.widgets['IPADDR'].get_text())
        print ipaddr
        if ipaddr:
            self.widgets['NETWORK'].set_text(int_to_ip_addr(ipaddr & netmask))
            self.widgets['BROADCAST'].set_text(int_to_ip_addr(ipaddr | ~netmask))


    def __init__(self,glade_file):
        global aval
        
        Applet.__init__(self,glade_file)
        self.widgets['subnetbits'].get_adjustment().connect("value_changed", self.on_subnetbits_value_changed)

        #### integrating with specific applet code.. case below for profile data found.
        if profmod.readprofile(modulename,aval):
            if aval['BOOTP']=='y':
                 self.widgets['notebook1'].set_page(0)
            elif aval['DHCP']=='y':
                 self.widgets['notebook1'].set_page(1)
            elif aval['IPADDR']!='':
                 self.widgets['notebook1'].set_page(2)
            for each in self.manualnames:
                try: self.widgets[each].set_text(aval[each])
                except: print "\nErrror setting:"+each+" with value of:"+aval[each]
                
        #### no profile data found so process like was previously done (grepping current config)
        else:
            print "readprof choked!"
            try:
                inf = open(self.fn)
                while 1:
                    line = inf.readline()
                    if not line: break
                    words = string.split(string.strip(line), '=')
                    if len(words) == 2:
                        name = words[0]
                        val = words[1][1:-1]   # strip off quotes
                        if name == "BOOTP" and val == "y":
                            self.widgets['notebook1'].set_page(0)
                        elif name == "DHCP" and val == "y":             #### changed logic to elif's for bootp,ipaddr.. more appropro?
                            self.widgets['notebook1'].set_page(1)       
                        elif name == "IPADDR" and val != "":
                            self.widgets['notebook1'].set_page(2)
                        if name in self.manualnames:
                            self.widgets[name].set_text(val)
                inf.close()
            except:
                raise
        
    def save(self,msgbox=FALSE):

        if self.widgets['notebook1'].get_current_page() == 0: aval['BOOTP']='y'
        else: aval['BOOTP']='n'
        if self.widgets['notebook1'].get_current_page() == 1: aval['DHCP']='y'
        else: aval['DHCP']='n'

        for each in self.manualnames:
            #print "setting "+each
            try: aval[each]=self.widgets[each].get_text()
            except: print "\nErrror saving value for :"+each
        if (profmod.writeprofile(modulename,aval)==0): 
            print "**Applet data save has a problem!!**"
            sys.exit(0)
        
        Applet.save(self)
    def activate(self):
        global aval
        mnames = ['DHCP','BOOTP','IPADDR', 'NETMASK', 'NETWORK', 'BROADCAST', 'GATEWAY', 'DHCP_HOSTNAME']
        fn = '/etc/network.opts'
        try:
            inf = open(self.fn)
            outf = open(self.fn+'.new','w')
            while 1:
                line = inf.readline()
                if not line: break
                words = string.split(string.strip(line), '=')
                if len(words) == 2:
                    name = words[0]
                    if name in mnames:
                        outf.write('    '+name+'="'+aval[name]+'"\n')
                    else:
                        outf.write(line)
                else:
                    outf.write(line)
            inf.close()
            outf.close()
            os.rename(self.fn+'.new', self.fn)
        except:
            raise
applet_instance = applet(glade_file)
